#pragma once
#include<string>
#include "Struct.h"
#include<vector>
#include <set>
#include <ranges>
class MeshLoader {
public:

    //!!! ИСПРАВЛЕНО Где виртуалдьный деструктор?
	virtual ~MeshLoader() = default;
	virtual void LoadMesh(const std::string&) = 0;
	std::vector<Node>& GetNodes();
	Node get_node(rsize_t id);
	std::vector<FiniteElement>& GetFE();
	std::vector<BoundaryFiniteElement>& GetBFE();
	void Print_Data();
	std::vector<int> findFE(size_t id1, size_t id2, size_t id3);
	std::vector<FiniteElement> findEdge(size_t id1, size_t id2);
	std::vector<size_t> vertex_nodes_by_surface_ID(size_t id);
	std::vector<std::set<size_t>>  GetNodesNeighbors();
	std::vector<Node> getMaterialID(size_t id);
	std::vector<BoundaryFiniteElement> getBoundaryFiniteID(size_t id);
	Node& Get_Node_by_ID(size_t n_id);
	void InsertNewNodes();



	void sort_range(const std::string& filepath);


protected:
	std::vector<Node> nodes;
	std::vector<FiniteElement> finiteElements;
	std::vector< BoundaryFiniteElement> boundaryFiniteElements;
};

